<?php

namespace Tests\Unit\Services;

use App\Services\External\Shimotomo\ShimotomoApiErrorException;
use App\Services\External\ShimotomoService;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\TransferException;
use Illuminate\Http\Response;
use Mockery;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\StreamInterface;
use Tests\TestCase;
use RuntimeException;

class ShimotomoServiceTest extends TestCase
{
    public function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
    }

    /**
     * @throws ShimotomoApiErrorException
     */
    public function testAuthWithRuntimeException()
    {
        $requestClientMock = Mockery::mock(ClientInterface::class);
        $requestClientMock->shouldReceive('request')
            ->andThrow(RuntimeException::class);

        $this->expectException(ShimotomoApiErrorException::class);

        $shimotomoService = new ShimotomoService($requestClientMock);
        $shimotomoService->auth();
    }

    /**
     * @throws ShimotomoApiErrorException
     */
    public function testAuthWithGuzzleTransferException()
    {
        $requestClientMock = Mockery::mock(ClientInterface::class);
        $requestClientMock->shouldReceive('request')
            ->andThrow(TransferException::class);

        $this->expectException(ShimotomoApiErrorException::class);

        $shimotomoService = new ShimotomoService($requestClientMock);
        $shimotomoService->auth();
    }

    public function testAuthWithNoSuccessCode()
    {
        $requestClientMock = Mockery::mock(ClientInterface::class);
        $responseMock = Mockery::mock(ResponseInterface::class);
        $streamMock = Mockery::mock(StreamInterface::class);
        $streamMock->shouldReceive('getContents')
            ->andReturn(json_encode([]));

        $responseMock->shouldReceive('getBody')
            ->andReturn($streamMock);
        $responseMock->shouldReceive('getStatusCode')
            ->andReturn(Response::HTTP_BAD_REQUEST);
        $requestClientMock->shouldReceive('request')
            ->andReturn($responseMock);

        $this->expectException(ShimotomoApiErrorException::class);

        $shimotomoService = new ShimotomoService($requestClientMock);
        $shimotomoService->auth();
    }

    /**
     * @throws ShimotomoApiErrorException
     */
    public function testAuthWithSuccess()
    {
        $data = [
            "partnerId" => "195",
            "memberId" => "11344",
            "result" => [
                "code" => "200",
                "description" => "Token generated successfully"
            ],
            "timestamp" => "2018-06-09 12:47:43",
            "LoginName" => "testdoc",
            "AuthToken" => "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJzdWIiOiJjb25tZXJjaGFudDEiLCJyb2xlIjoibWVyY
                            2hhbnQiLCJpc3MiOiJQWiIsImV4cCI6MTUwMTE0NjY0MX0.TFmGGKDUgkktmZQvrUTeox1buH1J6lgBVE3Mcy8OVjA"
        ];
        $requestClientMock = Mockery::mock(ClientInterface::class);
        $responseMock = Mockery::mock(ResponseInterface::class);
        $streamMock = Mockery::mock(StreamInterface::class);
        $streamMock->shouldReceive('getContents')
            ->andReturn(json_encode($data));

        $responseMock->shouldReceive('getBody')
            ->andReturn($streamMock);
        $responseMock->shouldReceive('getStatusCode')
            ->andReturn(Response::HTTP_OK);
        $requestClientMock->shouldReceive('request')
            ->andReturn($responseMock);

        $shimotomoService = new ShimotomoService($requestClientMock);
        $shimotomoService->auth();

        $this->assertEquals($data['AuthToken'], $shimotomoService->getAuthToken());
    }
}
